<?php
/*
   Configure captchaphp module and include it.
*/


if (empty($SERVER_URL)) {
  // In case of direct call (to get the image and the javascript), $SERVER_URL
  //  is not defined, so we compute it here from server parameters.

  $wccaptcha_proto = empty($_SERVER['HTTPS']) ? "http": "https";
  $wccaptcha_port = empty($_SERVER['SERVER_PORT'])? "": $_SERVER['SERVER_PORT'];

  if ($wccaptcha_port == ($wccaptcha_proto == "http"? 80: 443))
    $wccaptcha_port = "";
  else
    $wccaptcha_port = ":$wccaptcha_port";

  $SERVER_URL = "$wccaptcha_proto://{$_SERVER[SERVER_NAME]}$wccaptcha_port/";

  if (!empty($_SERVER['REQUEST_URI'])) {
    $wccaptcha_uripath = preg_split('/\//', $_SERVER['REQUEST_URI'], -1,
     PREG_SPLIT_NO_EMPTY);
    $wccaptcha_filepath = preg_split('/[\/]/', $_SERVER['SCRIPT_FILENAME'], -1,
     PREG_SPLIT_NO_EMPTY);

    while (count($wccaptcha_filepath) > 0 && count($wccaptcha_uripath) > 0) {
      array_pop($wccaptcha_uripath);
      array_pop($wccaptcha_filepath);

      if (is_dir('/' . implode('/', $wccaptcha_filepath) . "/includes")) {
        $SERVER_URL .= implode('/', $wccaptcha_uripath) . '/';
        break;
      }
    }
  }
} else {
  // The translate function is not available within direct calls. Happily,
  //  we only need the following definitions in non-direct calls.

  @define('CAPTCHA_PROMPT_TEXT', translate('Enter the correct letters and numbers from the image into the text box...'));
  @define('CAPTCHA_WHATIS_TEXT', translate('What is %s ='));
  @define('CAPTCHA_REDRAW_TEXT', translate('click on image to redraw'));
}

@define('CAPTCHA_INVERSE', 0);		// white or black(=1)
@define("CAPTCHA_NEW_URLS", 0);		// Force captcha only when URLs submitted
@define('CAPTCHA_BASE_URL', $SERVER_URL . "includes/classes/wccaptcha.php");
include_once('captchaphp/captcha.php');	// Will include it from include_path.
?>
